<?php
  $GLOBALS["genres"] = array(
    // The "original" genres
    'Blues', 'Classic Rock', 'Country', 'Dance', 'Disco', 'Funk',
    'Grunge', 'Hip-Hop', 'Jazz', 'Metal', 'New Age', 'Oldies', 'Other',
    'Pop', 'R&B', 'Rap', 'Reggae', 'Rock', 'Techno', 'Industrial',
    'Alternative', 'Ska', 'Death Metal', 'Pranks', 'Soundtrack',
    'Euro-Techno', 'Ambient', 'Trip-Hop', 'Vocal', 'Jazz+Funk', 'Fusion',
    'Trance', 'Classical', 'Instrumental', 'Acid', 'House', 'Game',
    'Sound Clip', 'Gospel', 'Noise', 'Alternative Rock', 'Bass', 'Soul',
    'Punk', 'Space', 'Meditative', 'Instrumental Pop', 'Instrumental Rock',
    'Ethnic', 'Gothic', 'Darkwave', 'Techno-Industrial', 'Electronic',
    'Pop-Folk', 'Eurodance', 'Dream', 'Southern Rock', 'Comedy', 'Cult',
    'Gangsta', 'Top 40', 'Christian Rap', 'Pop/Funk', 'Jungle',
    'Native US', 'Cabaret', 'New Wave', 'Psychadelic', 'Rave', 'Showtunes',
    'Trailer', 'Lo-Fi', 'Tribal', 'Acid Punk', 'Acid Jazz', 'Polka',
    'Retro', 'Musical', 'Rock & Roll', 'Hard Rock',
    // from Winamp 1.?
    'Folk', 'Folk-Rock', 'National Folk', 'Swing', 'Fast Fusion',
    'Bebob', 'Latin', 'Revival', 'Celtic', 'Bluegrass', 'Avantgarde',
    'Gothic Rock', 'Progressive Rock', 'Psychedelic Rock',
    'Symphonic Rock', 'Slow Rock', 'Big Band', 'Chorus', 'Easy Listening',
    'Acoustic', 'Humour', 'Speech', 'Chanson', 'Opera', 'Chamber Music',
    'Sonata', 'Symphony', 'Booty Bass', 'Primus', 'Porn Groove', 'Satire',
    // from Winamp 1.7
    'Slow Jam', 'Club', 'Tango', 'Samba', 'Folklore',
    // from Winamp 1.90
    'Ballad', 'Power Ballad', 'Rhytmic Soul', 'Freestyle', 'Duet',
    'Punk Rock', 'Drum Solo', 'Acapella', 'Euro-House', 'Dance Hall',
    'Goa', 'Drum & Bass', 'Club-House', 'Hardcore', 'Terror', 'Indie',
    'BritPop', 'Negerpunk', 'Polsk Punk', 'Beat', 'Christian Gangsta Rap',
    'Heavy Metal', 'Black Metal', 'Crossover', 'Contemporary Christian',
    'Christian Rock',
    // from Winamp 1.91
    'Merengue', 'Salsa', 'Trash Metal', 'Anime', 'Jpop', 'Synthpop', // More?
  );
  class id3v1 {
    var $is_valid     = false;
    var $artist       = "";
    var $title        = "";
    var $album        = "";
    var $year         = "";
    var $comment      = "";
    var $track_byte   = 0;
    var $track_number = 0;
    var $genre_byte   = 255;
    var $genre_text   = "";
    
    function id3v1 ($filename) {
      if (file_exists($filename) && is_readable($filename)) {
        $file = fopen($filename, "rb");
        fseek($file, filesize($filename) - 128);
        $data = fread($file, 128);
        fclose($file);
        if (substr($data, 0, 3) === 'TAG') {
          $this->is_valid = true;
          $this->artist  = $this->strippad(substr($data, 3, 30));
          $this->title   = $this->strippad(substr($data, 33, 30));
          $this->album   = $this->strippad(substr($data, 63, 30));
          $this->year    = $this->strippad(substr($data, 93, 4));
          $this->comment = $this->strippad(substr($data, 97, 29));
          $this->track_byte = substr($data, 126, 1);
          $this->track_number = ord($this->track_byte);
          $this->genre_byte = substr($data, 127, 1);
          if (isset($GLOBALS["genres"][ord($this->genre_byte)])) {
            $this->genre_text = $GLOBALS["genres"][ord($this->genre_byte)];
          }
        }
      }
    }

    function strippad ($data) {
      return trim(strtr($data, chr(0), ' '));
    }
  }

?>